<template>
  <div>
    <v-card flat class="pa-10">
      <v-row justify="center">
        <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
          <v-card class="mx-auto">
            <v-toolbar color="grey" dark>
              <v-spacer></v-spacer>
              <v-text-field
                v-model="searchDocumentosGrupo"
                label="Buscar"
                flat
                dark
                solo-inverted
                append-icon="mdi-magnify"
                hide-details
                clear-icon="mdi-close-circle-outline"
              ></v-text-field>
            </v-toolbar>
            <v-list
              height="300"
              max-height="300"
              style="overflow: auto;"
              subheader
              three-line
            >
              <v-subheader>DOCUMENTOS COMPARTIDOS CON EL GRUPO</v-subheader>
              <v-list-item-group
                v-model="selectedDocumentosGrupo"
                color="primary"
              >
                <v-list-item
                  :value="item"
                  v-for="(item, indexItem) in searchedDocumentosGrupo"
                  :key="indexItem"
                >
                  <template v-slot:default="{ active }">
                    <v-list-item-avatar>
                      <v-icon large>mdi-file-document-outline</v-icon>
                    </v-list-item-avatar>
                    <v-list-item-content>
                      <v-list-item-title>
                        <router-link
                          class="text-decoration-underline"
                          :to="toFolioView(item.folio)"
                        >
                          {{ item.folio.documento.titulo }}
                        </router-link>
                      </v-list-item-title>
                      <v-list-item-subtitle>
                        Folio : {{ item.folio.idFolio }}
                      </v-list-item-subtitle>
                      <v-list-item-subtitle>
                        <v-breadcrumbs
                          class="pa-0"
                          divider="|"
                          :items="breadcrumbsNegocios(item.folio.rutas)"
                        ></v-breadcrumbs>
                      </v-list-item-subtitle>
                      <v-list-item-subtitle>
                        <template
                          v-for="(itemEtiqueta, indexItemEtiqueta) in item.folio
                            .etiquetas"
                        >
                          <v-chip class="mr-2" small :key="indexItemEtiqueta">{{
                            itemEtiqueta.descripcion
                          }}</v-chip>
                        </template>
                      </v-list-item-subtitle>
                    </v-list-item-content>
                    <v-list-item-action>
                      <v-tooltip bottom>
                        <template v-slot:activator="{ on, attrs }">
                          <v-btn
                            class="white--text"
                            color="grey"
                            v-bind="attrs"
                            v-on="on"
                            @click="deleteDocumentoGrupo(indexItem, item)"
                          >
                            <v-icon>mdi-share-off-outline</v-icon>
                          </v-btn>
                        </template>
                        <span>Dejar de compartir</span>
                      </v-tooltip>
                    </v-list-item-action>
                  </template>
                </v-list-item>
              </v-list-item-group>
            </v-list>
          </v-card>
        </v-col>
        <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
          <v-card class="mx-auto">
            <v-toolbar color="grey" dark>
              <v-spacer></v-spacer>
              <v-text-field
                v-model="searchDocumentosDisponibles"
                label="Buscar"
                flat
                dark
                solo-inverted
                append-icon="mdi-magnify"
                hide-details
                clear-icon="mdi-close-circle-outline"
              ></v-text-field>
            </v-toolbar>
            <v-list
              height="300"
              max-height="400"
              style="overflow: auto;"
              subheader
              three-line
            >
              <v-subheader>DOCUMENTOS POR COMPARTIR</v-subheader>
              <v-list-item-group
                v-model="selectedDocumentosDisponibles"
                color="primary"
              >
                <v-list-item
                  :value="item"
                  v-for="(item, indexItem) in searchedDocumentosDisponibles"
                  :key="indexItem"
                >
                  <v-list-item-avatar>
                    <v-icon large>mdi-file-document-outline</v-icon>
                  </v-list-item-avatar>
                  <v-list-item-content>
                    <v-list-item-title>
                      <router-link
                        class="text-decoration-underline"
                        :to="toFolioView(item.folio)"
                      >
                        {{ item.folio.documento.titulo }}
                      </router-link>
                    </v-list-item-title>
                    <v-list-item-subtitle>
                      Folio : {{ item.folio.idFolio }}
                    </v-list-item-subtitle>
                    <v-list-item-subtitle>
                      <v-breadcrumbs
                        class="pa-0"
                        divider="|"
                        :items="breadcrumbsNegocios(item.folio.rutas)"
                      ></v-breadcrumbs>
                    </v-list-item-subtitle>
                    <v-list-item-subtitle>
                      <template
                        v-for="(itemEtiqueta, indexItemEtiqueta) in item.folio
                          .etiquetas"
                      >
                        <v-chip class="mr-2" small :key="indexItemEtiqueta">{{
                          itemEtiqueta.descripcion
                        }}</v-chip>
                      </template>
                    </v-list-item-subtitle>
                  </v-list-item-content>
                  <v-list-item-action>
                    <v-tooltip bottom>
                      <template v-slot:activator="{ on, attrs }">
                        <v-btn
                          class="white--text"
                          color="grey"
                          v-bind="attrs"
                          v-on="on"
                          @click="postDocumentoGrupo(indexItem, item)"
                        >
                          <v-icon>mdi-share-outline</v-icon>
                        </v-btn>
                      </template>
                      <span
                        >Compartir {{ item.folio.documento.titulo }} con el
                        grupo</span
                      >
                    </v-tooltip>
                  </v-list-item-action>
                </v-list-item>
              </v-list-item-group>
            </v-list>
          </v-card>
        </v-col>
      </v-row>
    </v-card>
  </div>
</template>
<script>
import store from "@/store";
const axios = store.state.axiosApiLocal;
const serviceCommons = store.state.serviceCommons;
export default {
  name: "Component-Documentos",
  props: ["grupoIn"],
  data() {
    return {
      searchDocumentosGrupo: null,
      searchDocumentosDisponibles: null,
      selectedDocumentosGrupo: null,
      selectedDocumentosDisponibles: null,
      documentosGrupo: [],
      documentosDisponibles: [],
      grupo: this.grupoIn,
    };
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
    searchedDocumentosDisponibles() {
      let tempData = this.documentosDisponibles;
      if (
        this.searchDocumentosDisponibles != "" &&
        this.searchDocumentosDisponibles
      ) {
        tempData = tempData.filter((item) => {
          let wordkeys = [];
          let folio = item.folio;
          let documento = folio.documento;
          let etiquetas = folio.etiquetas;
          let rutas = folio.rutas;
          let valuesDocumento = new Array();
          valuesDocumento.push(documento.titulo);
          let valuesEtiquetas = Object.values(etiquetas).map((item) => {
            return (item.descripcion + "").toUpperCase();
          });
          let valuesRutas = Object.values(rutas).map((item) => {
            return (item.unidadNegocio.descripcion + "").toUpperCase();
          });
          let valuesFolios = new Array();
          valuesFolios.push(folio.idFolio + "");
          wordkeys = wordkeys.concat(valuesDocumento);
          wordkeys = wordkeys.concat(valuesEtiquetas);
          wordkeys = wordkeys.concat(valuesRutas);
          wordkeys = wordkeys.concat(valuesFolios);
          let wordkeysJoined = wordkeys.join(" ");
          return wordkeysJoined.includes(
            this.searchDocumentosDisponibles.toUpperCase()
          );
        });
      }
      if (tempData.length > 0) {
        tempData = tempData.sort((a, b) => {
          let fa = a.folio.idFolio;
          let fb = b.folio.idFolio;
          if (fa < fb) {
            return -1;
          }
          if (fa > fb) {
            return 1;
          }
          return 0;
        });
      }
      return tempData;
    },
    searchedDocumentosGrupo() {
      let tempData = this.documentosGrupo;
      if (this.searchDocumentosGrupo != "" && this.searchDocumentosGrupo) {
        tempData = tempData.filter((item) => {
          let wordkeys = [];
          let folio = item.folio;
          let documento = folio.documento;
          let etiquetas = folio.etiquetas;
          let rutas = folio.rutas;
          let valuesDocumento = new Array();
          valuesDocumento.push(documento.titulo);
          let valuesEtiquetas = Object.values(etiquetas).map((item) => {
            return (item.descripcion + "").toUpperCase();
          });
          let valuesRutas = Object.values(rutas).map((item) => {
            return (item.unidadNegocio.descripcion + "").toUpperCase();
          });
          let valuesFolios = new Array();
          valuesFolios.push(folio.idFolio + "");
          wordkeys = wordkeys.concat(valuesDocumento);
          wordkeys = wordkeys.concat(valuesEtiquetas);
          wordkeys = wordkeys.concat(valuesRutas);
          wordkeys = wordkeys.concat(valuesFolios);
          let wordkeysJoined = wordkeys.join(" ");
          return wordkeysJoined.includes(
            this.searchDocumentosGrupo.toUpperCase()
          );
        });
      }
      if (tempData.length > 0) {
        tempData = tempData.sort((a, b) => {
          let fa = a.folio.idFolio;
          let fb = b.folio.idFolio;
          if (fa < fb) {
            return -1;
          }
          if (fa > fb) {
            return 1;
          }
          return 0;
        });
      }
      return tempData;
    },
  },
  methods: {
    breadcrumbsNegocios(rutas) {
      let breadcrumbs = [];
      let groupByDescripcion = this.serviceCommons.groupBy(
        "unidadNegocio.descripcion"
      );
      let rutasGrouped = groupByDescripcion(rutas);
      for (let attr in rutasGrouped) {
        breadcrumbs.push({
          text: attr,
        });
      }
      return breadcrumbs;
    },
    toFolioView(folioIn) {
      return {
        name: "modelo_negocio_documentos_visualizar_resumen_folio",
        query: {
          back: serviceCommons.objectToBase64({
            name: "modelo_negocio_accesos_grupos_edicion",
            params: {
              grupo: this.serviceCommons.objectToBase64(this.grupo),
            },
            query: {
              documentos: this.serviceCommons.objectToBase64({}),
            },
          }),
        },
        params: {
          folio: this.serviceCommons.objectToBase64({
            idFolio: folioIn.idFolio,
          }),
        },
      };
    },
    deleteDocumentoGrupo(indexItem, documentoGrupo) {
      axios
        .delete(
          "/modelo-negocio/accesos/grupos/v1/" +
            this.grupo.idGrupo +
            "/documentos/" +
            documentoGrupo.idDocumentoGrupo
        )
        .then((response) => {
          documentoGrupo.idDocumentoGrupo = null;
          this.documentosGrupo.splice(indexItem, 1);
          this.documentosDisponibles.push(documentoGrupo);
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        })
        .finally(() => {});
    },
    postDocumentoGrupo(indexItem, documentoGrupo) {
      let body = {
        idDocumento: documentoGrupo.folio.documento.idDocumento,
      };
      axios
        .post(
          "/modelo-negocio/accesos/grupos/v1/" +
            this.grupo.idGrupo +
            "/documentos",
          body
        )
        .then((response) => {
          let data = response.data;
          if (data) {
            documentoGrupo.idDocumentoGrupo = data.resultado.id;
            this.documentosGrupo.push(documentoGrupo);
            this.documentosDisponibles.splice(indexItem, 1);
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        })
        .finally(() => {});
    },
    getDocumentosGrupo() {
      this.loading = true;
      axios(
        "/modelo-negocio/accesos/grupos/v1/" +
          this.grupo.idGrupo +
          "/documentos"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            this.documentosGrupo = data.resultado.documentos;
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            this.documentosGrupo = [];
          } else {
            console.log(error);
          }
        })
        .finally(() => {
          this.loading = false;
        });
    },
    getDocumentosDisponibles() {
      this.loading = true;
      axios(
        "/modelo-negocio/accesos/grupos/v1/" +
          this.grupo.idGrupo +
          "/documentos/disponibles"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            this.documentosDisponibles = data.resultado.documentos;
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            this.documentosDisponibles = [];
          } else {
            console.log(error);
          }
        })
        .finally(() => {
          this.loading = false;
        });
    },
  },
  created() {
    this.getDocumentosGrupo();
    this.getDocumentosDisponibles();
  },
};
</script>
